Subject: Re: bug: hard links to soft links do not work
From: Sam Steingold <[email-masked]>
To: [email-masked]
Date: 01 Aug 2002 16:01:40 -0400
Newsgroups: gmane.os.cygwin

> * In message <[email-masked]>
> * On the subject of "Re: bug: hard links to soft links do not work"
> * Sent on Thu, 1 Aug 2002 15:21:04 -0400
> * Honorable Christopher Faylor <[email-masked]> writes:
>
> >> On Thu, Aug 01, 2002 at 02:19:11PM -0400, Sam Steingold wrote:
> >> >cygwin does not handle hard and soft links together:
> >> >
> >> >$ echo "foo" > foo
> >> >$ ln foo 1
> >> >$ cat 1
> >> >foo                             ; GOOD!
> >> >$ ln -s 1 2
> >> >$ cat 2
> >> >foo                             ; GOOD!
> >> >$ ln 2 3
> >> >$ cat 3
> >> ><some binary data instead of "foo">
> >> >$
> >> >
> >> >I.e., hard links to soft links do not work.
> >> 
> >> Funny, when I try this on linux, I get:
> >> 
> >>   % ln 2 3
> >>   ln: `2': warning: making a hard link to a symbolic link is not portable
> >
> >indeed - but it works on linux as expected.
> >cygwin should either barf of DTRT.
> >I take your reply to mean that this is not getting changed.
> 
> You can take almost any reply that I make as "Patches gratefully
> accepted."

Okay - you asked for it, you got it.  Almost.
I had to investigate the issue further, and it turned out that cygwin
is not the only system which has this problem, SVR4 being the other.
(see <http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/*checkout*/clisp/clisp/src/m4/ln.m4?rev=HEAD&content-type=text/plain>)

for that reason, CLISP comes with
<http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/*checkout*/clisp/clisp/utils/hln/>
which implements the correct behavior and works on cygwin too.

all you have to do is to look how clisp/utils/hln/ differs from what
you have in cygwin. :-)

thanks.

-- 
Sam Steingold (http://www.podval.org/~sds) running RedHat7.3 GNU/Linux
<http://www.camera.org> <http://www.iris.org.il> <http://www.memri.org/>
<http://www.mideasttruth.com/> <http://www.palestine-central.com/links.html>
Those who value Life above Freedom are destined to lose both.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/